# cap_app_api

CapAppApi - JavaScript client for cap_app_api
CapApp services.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0.rc-01
- Package version: 1.0.0.rc-01
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install cap_app_api --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var CapAppApi = require('cap_app_api');

var defaultClient = CapAppApi.ApiClient.instance;

// Configure OAuth2 access token for authorization: capapp_auth
var capapp_auth = defaultClient.authentications['capapp_auth'];
capapp_auth.accessToken = "YOUR ACCESS TOKEN"

var api = new CapAppApi.BookingApi()

var bookings = new CapAppApi.Bookings(); // {Bookings} The bookings for the week.


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
api.updateWeek(bookings, callback);

```

## Documentation for API Endpoints

All URIs are relative to *https://endpoints-dot-capappw.appspot.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CapAppApi.BookingApi* | [**updateWeek**](docs/BookingApi.md#updateWeek) | **POST** /bookings/update | Update a set of bookings for this week. Add if new.
*CapAppApi.UserApi* | [**getUser**](docs/UserApi.md#getUser) | **GET** /user/me | User profile
*CapAppApi.UserApi* | [**loginUser**](docs/UserApi.md#loginUser) | **POST** /user/login | Login a user and add the user if new.


## Documentation for Models

 - [CapAppApi.Booking](docs/Booking.md)
 - [CapAppApi.Bookings](docs/Bookings.md)
 - [CapAppApi.Error](docs/Error.md)
 - [CapAppApi.HasLongId](docs/HasLongId.md)
 - [CapAppApi.Paging](docs/Paging.md)
 - [CapAppApi.User](docs/User.md)
 - [CapAppApi.Users](docs/Users.md)


## Documentation for Authorization


### capapp_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: Not used
- **Scopes**: 
  - capapp: Perform actions on behalf of the CapApp organization.
  - user: Perform actions on behalf of an individual user.

