# CapAppApi.BookingApi

All URIs are relative to *https://endpoints-dot-capappw.appspot.com/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**updateWeek**](BookingApi.md#updateWeek) | **POST** /bookings/update | Update a set of bookings for this week. Add if new.


<a name="updateWeek"></a>
# **updateWeek**
> updateWeek(bookings)

Update a set of bookings for this week. Add if new.

### Example
```javascript
var CapAppApi = require('cap_app_api');
var defaultClient = CapAppApi.ApiClient.default;

// Configure OAuth2 access token for authorization: capapp_auth
var capapp_auth = defaultClient.authentications['capapp_auth'];
capapp_auth.accessToken = 'YOUR ACCESS TOKEN';

var apiInstance = new CapAppApi.BookingApi();

var bookings = new CapAppApi.Bookings(); // Bookings | The bookings for the week.


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.updateWeek(bookings, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookings** | [**Bookings**](Bookings.md)| The bookings for the week. | 

### Return type

null (empty response body)

### Authorization

[capapp_auth](../README.md#capapp_auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

