/**
 * CapApp API
 * CapApp services.
 *
 * OpenAPI spec version: 1.0.0.rc-01
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Bookings'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Bookings'));
  } else {
    // Browser globals (root is window)
    if (!root.CapAppApi) {
      root.CapAppApi = {};
    }
    root.CapAppApi.BookingApi = factory(root.CapAppApi.ApiClient, root.CapAppApi.Bookings);
  }
}(this, function(ApiClient, Bookings) {
  'use strict';

  /**
   * Booking service.
   * @module api/BookingApi
   * @version 1.0.0.rc-01
   */

  /**
   * Constructs a new BookingApi. 
   * @alias module:api/BookingApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the updateWeek operation.
     * @callback module:api/BookingApi~updateWeekCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a set of bookings for this week. Add if new.
     * @param {module:model/Bookings} bookings The bookings for the week.
     * @param {module:api/BookingApi~updateWeekCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.updateWeek = function(bookings, callback) {
      var postBody = bookings;

      // verify the required parameter 'bookings' is set
      if (bookings === undefined || bookings === null) {
        throw new Error("Missing the required parameter 'bookings' when calling updateWeek");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['capapp_auth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/bookings/update', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
