/**
 * CapApp API
 * CapApp services.
 *
 * OpenAPI spec version: 1.0.0.rc-01
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Error', 'model/User'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Error'), require('../model/User'));
  } else {
    // Browser globals (root is window)
    if (!root.CapAppApi) {
      root.CapAppApi = {};
    }
    root.CapAppApi.UserApi = factory(root.CapAppApi.ApiClient, root.CapAppApi.Error, root.CapAppApi.User);
  }
}(this, function(ApiClient, Error, User) {
  'use strict';

  /**
   * User service.
   * @module api/UserApi
   * @version 1.0.0.rc-01
   */

  /**
   * Constructs a new UserApi. 
   * @alias module:api/UserApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getUser operation.
     * @callback module:api/UserApi~getUserCallback
     * @param {String} error Error message, if any.
     * @param {module:model/User} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * User profile
     * The user profile endpoint returns information about the CapApp user that has authorized with the application.
     * @param {module:api/UserApi~getUserCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/User}
     */
    this.getUser = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['capapp_auth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = User;

      return this.apiClient.callApi(
        '/user/me', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the loginUser operation.
     * @callback module:api/UserApi~loginUserCallback
     * @param {String} error Error message, if any.
     * @param {module:model/User} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Login a user and add the user if new.
     * Login a user and additionally add a new user if the user is new. Requires information obtained via a successful Facebook login. Refresh the Facebook user access token if the user already exists. The returned CapApp user access token will be used for authentication on other API calls.
     * @param {String} name The user name.
     * @param {Object} opts Optional parameters
     * @param {String} opts.tag An optional tag attached to any data created. Typically used for testing.
     * @param {module:api/UserApi~loginUserCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/User}
     */
    this.loginUser = function(name, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'name' is set
      if (name === undefined || name === null) {
        throw new Error("Missing the required parameter 'name' when calling loginUser");
      }


      var pathParams = {
      };
      var queryParams = {
        'name': name,
        'tag': opts['tag']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['capapp_auth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = User;

      return this.apiClient.callApi(
        '/user/login', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
