/**
 * CapApp API
 * CapApp services.
 *
 * OpenAPI spec version: 1.0.0.rc-01
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/HasLongId'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./HasLongId'));
  } else {
    // Browser globals (root is window)
    if (!root.CapAppApi) {
      root.CapAppApi = {};
    }
    root.CapAppApi.User = factory(root.CapAppApi.ApiClient, root.CapAppApi.HasLongId);
  }
}(this, function(ApiClient, HasLongId) {
  'use strict';




  /**
   * The User model module.
   * @module model/User
   * @version 1.0.0.rc-01
   */

  /**
   * Constructs a new <code>User</code>.
   * A user.
   * @alias module:model/User
   * @class
   * @implements module:model/HasLongId
   * @param id {Number} A unique ID for the item.
   */
  var exports = function(id) {
    var _this = this;

    HasLongId.call(_this, id);








  };

  /**
   * Constructs a <code>User</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/User} obj Optional instance to populate.
   * @return {module:model/User} The populated <code>User</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      HasLongId.constructFromObject(data, obj);
      if (data.hasOwnProperty('facebookID')) {
        obj['facebookID'] = ApiClient.convertToType(data['facebookID'], 'String');
      }
      if (data.hasOwnProperty('accessToken')) {
        obj['accessToken'] = ApiClient.convertToType(data['accessToken'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('userToken')) {
        obj['userToken'] = ApiClient.convertToType(data['userToken'], 'String');
      }
      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
      if (data.hasOwnProperty('picture')) {
        obj['picture'] = ApiClient.convertToType(data['picture'], 'String');
      }
    }
    return obj;
  }

  /**
   * The person's Facebook ID.
   * @member {String} facebookID
   */
  exports.prototype['facebookID'] = undefined;
  /**
   * The person's Facebook access token.
   * @member {String} accessToken
   */
  exports.prototype['accessToken'] = undefined;
  /**
   * The person's full name.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * A user access token used for authentication on other calls.
   * @member {String} userToken
   */
  exports.prototype['userToken'] = undefined;
  /**
   * The person's first name.
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * The person's last name.
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * Email address of the CapApp user
   * @member {String} email
   */
  exports.prototype['email'] = undefined;
  /**
   * Image URL of the CapApp user.
   * @member {String} picture
   */
  exports.prototype['picture'] = undefined;

  // Implement HasLongId interface:
  /**
   * A unique ID for the item.
   * @member {Number} id
   */
exports.prototype['id'] = undefined;

  /**
   * An optional tag attached to the item when it was created.
   * @member {String} tag
   */
exports.prototype['tag'] = undefined;



  return exports;
}));


